<?php

namespace Center\Capsule\Constants;


class BaseConst
{
    /**
     * 获取map
     *
     * @param string $const
     * @return array
     */
    public static function getMap($const = '')
    {
        if (!empty($const)) {
            return array_column(static::${$const}, 'title', 'value');
        }
        return [];
    }

    /**
     * getValue
     *
     * @param string $title
     * @param string $const
     * @return string
     */
    public static function getValue($title = '', $const = '')
    {
        $map = self::getMap($const);
        $map = array_flip($map);
        return isset($map[$title]) ? $map[$title] : '';
    }


    /**
     * getValueByKey
     *
     * @param string $key
     * @param string $const
     * @return string
     */
    public static function getValueByKey($key = '', $const = '')
    {
        $map = array_flip(self::getMapKey($const));
        return $map[$key] ?? '';
    }

    /**
     * getTitle
     *
     * @param string $value
     * @param string $const
     * @return mixed|string
     */
    public static function getTitle($value = '', $const = '')
    {
        $map = self::getMap($const);
        return isset($map[$value]) ? $map[$value] : '';
    }

    /**
     * getMapWithTitle
     *
     * @param string $const
     * @return array
     */
    public static function getMapWithTitle($const = '')
    {
        $map = self::getMap($const);
        return array_values($map);
    }

    /**
     * getMapWithValue
     *
     * @param string $const
     * @return array
     */
    public static function getMapWithValue($const = '')
    {
        $map = self::getMap($const);
        return array_keys($map);
    }

    /**
     * getMapKey
     *
     * @param string $const
     * @return null
     */
    public static function getMapKey($const = '')
    {
        static $map = null;
        if (is_null($map)) {
            $temp = static::${$const};
            foreach ($temp as $k => $v) {
                $map[$v['value']] = $k;
            }
        }
        return $map;
    }
}