<?php

namespace Center\Capsule\Constants;


class ServiceConst extends BaseConst
{
    public static $services = [
        'user'        => [
            'title' => '用户中心',
            'value' => 'user'
        ],
        'application' => [
            'title' => '应用中心',
            'value' => 'application'
        ]
    ];

    /**
     * getServiceHost
     *
     * @param $service
     * @return mixed|string
     * @throws \Exception
     */
    public static function getServiceHost($service)
    {
        if (isset(static::$services[$service]['value']) && env('APP_ENV') != 'local') {
            $host = \Overlu\Reget\Reget::getInstance()->service(static::$services[$service]['value']);
            $host = empty($host) ? static::$services[$service]['value'] : $host;
            return 'http://' . $host;
        } else {
            $config = config('capsule');
            return $config['gateway_host'].'/'.$service;
        }
    }
}