<?php

namespace Center\Capsule\Controllers\Requests;


use Center\Capsule\Controllers\Traits\ApiResponseTrait;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Contracts\Validation\Validator;

abstract class BaseRequest extends FormRequest
{
    use ApiResponseTrait;

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    abstract public function authorize();

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    abstract public function rules();

    /**
     * Rewrite failedValidation function.
     *
     * @param Validator $validator
     *
     * @return Void
     */
    protected function failedValidation(Validator $validator)
    {
         $this->errorReport($validator->errors()->first());
    }
}
