<?php

namespace Center\Capsule\Controllers\Traits;

use Illuminate\Http\Exceptions\HttpResponseException;

trait ApiResponseTrait
{
    /**
     * 成功
     *
     * @param null $data
     * @return void
     */
    public function success($data = null)
    {
        $this->rawJson($data);
    }

    /**
     * 错误
     *
     * @param null        $errorCode
     * @param string|null $errorMessage
     * @return void
     */
    public function error($errorCode = null, string $errorMessage = null)
    {
        $this->rawJson([], $errorCode, $errorMessage);
    }

    /**
     * rawJson
     *
     * @param        $result
     * @param int    $errorCode
     * @param string $errorMessage
     * @return void
     */
    public function rawJson($result, $errorCode = 200, $errorMessage = "")
    {
        throw new HttpResponseException(response()->json([
            'error_code'    => $errorCode,
            'error_message' => $errorMessage,
            'result'        => empty($result) ? (object)$result : $result
        ]));
    }

    /**
     * 带配置错误信息输出
     *
     * @param $param
     * @return void
     */
    public function errorReport($param)
    {
        $message = trans('messages.' . $param);
        if (is_array($message)) {
            foreach ($message as $k => $v){
                $$k = $v;
            }
        } else {
            list($error_code, $error_message) = [
                6500,
                'default_error'
            ];
        }
        $this->error($error_code, $error_message);
    }
}