<?php

namespace Center\Capsule\Models;


use Rutorika\Sortable\SortableTrait;

class ModelProperties extends BaseModel
{
    use SortableTrait;

    protected static $sortableField = 'sort';

    protected $fillable = [];

    protected $guarded = [];

    protected $casts = [
        'property_option' => 'array',
        'option'          => 'array',
        'widget'          => 'array',
        'property_filter' => 'array',
        'filter'          => 'array'
    ];

    public function models()
    {
        return $this->hasMany(Models::class, 'id', 'model_id');
    }

    public static function selectMap()
    {
        return [
            'id',
            'property_type as type',
            'property_key as key',
            'property_name as name',
            'property_filter as filter',
            'property_option as option',
            'visibility',
            'widget',
            'systematic'
        ];
    }


}
