<?php

namespace Center\Capsule\Models;


use Illuminate\Database\Eloquent\Builder;

class Models extends BaseModel
{
    protected $fillable = [];

    protected $guarded = [];

    public static $embedField = [
        'id' => [
            'name' => '主键id'
        ],
        'user_id'     => [
            'name' => '用户id'
        ],
        'member_id'   => [
            'name' => '会员id'
        ],
        'device'      => [
            'name' => '设备'
        ],
        'sort'        => [
            'name' => '排序'
        ],
        'created_at'  => [
            'name' => '创建时间'
        ],
        'updated_at'  => [
            'name' => '更新时间'
        ],
        'created_uid' => [
            'name' => '创建人'
        ],
        'updated_uid' => [
            'name' => '修改人'
        ],
        'deleted_at'  => [
            'name' => '软删除'
        ]
    ];

    /**
     * getEmbedField
     *
     * @return array
     */
    public static function getEmbedField()
    {
        //todo 数据库获取
        return static::$embedField;
    }

    public function scopeModelName($query, $model_name)
    {
        /**
         * @var Builder $query
         */
        return $query->where('model_name', 'like', '%' . $model_name . '%');
    }

    public function scopeModelStatus($query, $model_status)
    {
        /**
         * @var Builder $query
         */
        return $query->where('model_status', $model_status);
    }
}