<?php

namespace Center\Capsule\Models;


use Center\Capsule\Constants\PresetConst;

use Illuminate\Database\Eloquent\Builder;

/**
 * @method static Builder enable(Builder $query)
 */
class PresetProperties extends BaseModel
{

    protected $guarded = [];

    protected $casts = [
        'property_option' => 'array',
        'option'          => 'array',
    ];

    public static function filedMap()
    {
        return [
            'property_key as key',
            'property_type as type',
            'property_name as name',
            'property_filter as filter',
            'property_option as option',
            'property_status as status',
            'created_uid',
            'updated_uid',
            'created_at',
            'updated_at'
        ];
    }

    /**
     * 只查可以用
     *
     * @param  \Illuminate\Database\Eloquent\Builder $query
     * @return \Illuminate\Database\Eloquent\Builder
     */
    public function scopeEnable($query)
    {
        return $query->where('property_status', PresetConst::$propertyStatus['enable']['value']);
    }

}

