<?php

namespace Center\Capsule\Services\Models\Assist;


use Center\Capsule\Constants\ServiceConst;
use Center\Capsule\Services\Extra\RequestService;

class Application
{
    /**
     * 通过应用的key获取应用的id
     *
     * @param        $application_key
     * @param string $type
     * @param string $key
     * @return bool|string
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public static function getApplicationIdByKey($application_key, $type = '', $key = '')
    {
        static $data = null;
        $config = config('capsule');
        if ($key) {
            $api = $config['application']['get_application_detail_by_id'];
        } else {
            $api = $config['application']['get_application_detail_by_key'];
        }
        $res = RequestService::getInstance()
            ->get(static::getApplicationHost() . $api . $application_key);

        if ($res->isSuccess() && $data = $res->getResult()) {
            return $data ? ($type ? $data : $data['id']) : '';
        }
        return false;
    }

    /**
     * getApplicationHost
     *
     * @param string $key
     * @return mixed|string
     */
    public static function getApplicationHost($key = 'application')
    {
        try {
            return ServiceConst::getServiceHost($key);
        } catch (\Exception $e) {
            //todo
        }
        return null;
    }
}