<?php

namespace Center\Capsule\Services\Models\Facades;

use Center\Capsule\Services\Models\Facades\Resolve\ModelMange;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Support\Facades\Facade;


/**
 * @method static \Center\Capsule\Models\BaseModel getModel(string $key)
 * @method static Builder[]|Collection getProperties(string $model_key)
 * @method static array getAllowProperties(string $model_key)
 *
 *
 * @see \Center\Capsule\Services\Models\Facades\Resolve\ModelMange
 */

class Model extends Facade
{
    /**
     * Get the registered name of the component.
     *
     * @return string
     */
    protected static function getFacadeAccessor()
    {
        return new ModelMange();
    }

}