<?php

namespace App\Models\Dynamic;

use Center\Capsule\Models\BaseModel;
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Rutorika\Sortable\SortableTrait;

class {{MODEL_KEY}} extends BaseModel
{
    use SortableTrait;

    protected $table = '{{MODEL_KEY}}';

    protected static $sortableField = 'sort';

    public function createTable()
    {
        Schema::create('{{MODEL_KEY}}', function (Blueprint $table) {
            $table->bigInteger('id')->index('idx_model_id');
            $table->bigInteger('company_id')->index('idx_company_id')->default(0)->comment('公司id');
            $table->bigInteger('user_id')->default(0)->comment('用户id');
            $table->bigInteger('member_id')->default(0)->comment('会员id');
            $table->string('device',100)->default('')->comment('设备id');
            $table->bigInteger('created_uid')->comment('创建人')->default(0);
            $table->bigInteger('updated_uid')->comment('更新人')->default(0);
            $table->integer('sort')->index('idx_sort')->comment('排序');
            $table->timestamps();
            $table->softDeletes();
            $table->primary('id')->comment('{{MODEL_NAME}}');
        });
        return $this;
    }
}
