<?php

namespace Center\Capsule\Services\Property\Build\Alter;

use Center\Capsule\Services\Property\Build\Alter;
use Center\Capsule\Services\Property\Build\BaseProperty;
use Center\Capsule\Services\Property\Build\VarCharProperty;
use Center\Capsule\Services\Property\Interfaces\AlterInterface;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class VarCharAlter extends Alter implements AlterInterface
{
    /**
     * @var BaseProperty
     */
    public $property = null;

    public function setProperty(VarCharProperty $property)
    {
        $this->property = $property;
        return $this;
    }

    public function make()
    {
        Schema::table($this->property->modelKey, function (Blueprint $table) {
            $table->string($this->property->getKey())
                ->comment($this->property->name)
                ->default('')->change();
        });
    }
}