<?php

namespace Center\Capsule\Services\Property\Build;


use Center\Capsule\Models\ModelProperties;
use Center\Capsule\Services\Property\Exception\PropertyException;
use Illuminate\Support\Facades\DB;

class SystematicProperty extends BaseProperty
{
    public $type = 'systematic';

    /**
     * 绑定数据到当前对象
     *
     * @return mixed
     */
    public function bind()
    {
        return $this;
    }

    /**
     * bindModel
     *
     * @return mixed|void
     * @throws PropertyException
     */
    public function bindModel()
    {
        throw new PropertyException('systematic type is forbidden');
    }


    /**
     * update
     *
     * @return bool
     */
    public function update()
    {
        DB::transaction(function () {
            $model = new ModelProperties();
            (new Model($this->getPropertyModelByKey($model), $this->modelKey, $this))
                ->setSystematic(true)->updateDb(function () {
                    //
                })->checkTable();
        });
        return true;
    }

}