<?php

namespace Center\Capsule\Services\Property\Build;


use Center\Capsule\Models\ModelProperties;
use Center\Capsule\Services\Property\Build\Traits\AlterTrait;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;


class TextProperty extends BaseProperty
{
    use AlterTrait;
    public $type = 'text';

    public $stringNum = 255;

    public $varCharType = 'default';

    /**
     * 绑定数据到当前对象
     *
     * @return mixed
     */
    public function bind()
    {
        return $this;
    }

    public function bindModel()
    {
        DB::transaction(function () {
            (new Model((new ModelProperties()), $this->modelKey, $this))
                ->writeDb(function () {
                    $this->make();
                })->checkTable();
        });
        return true;
    }

    protected function make()
    {
        Schema::table($this->modelKey, function (Blueprint $table) {
            $table = $table->text($this->getKey())
                ->nullable()
                ->comment($this->name);
            if ($this->alter) {
                $table->change();
            }
        });
    }

    /**
     * update
     *
     * @return bool
     */
    public function update()
    {
        DB::transaction(function () {
            $model = new ModelProperties();
            (new Model($this->getPropertyModelByKey($model), $this->modelKey, $this))
                ->updateDb(function () {
                    (new Alter())->getPropertyAlterByKey($this->type)
                        ->setProperty($this)
                        ->make()
                        ->make();
                })->checkTable();
        });
        return true;
    }
}