<?php

namespace Center\Capsule\Services\Property\Build\Traits;


use Center\Capsule\Services\Property\Exception\PropertyException;

trait ConvertTrait
{
    public static function enableMap()
    {

    }

    public static function enableOptionTypeMap()
    {
        return ['varchar', 'number'];
    }

    /**
     * convert
     *
     * @param $data
     * @param $origin
     * @throws PropertyException
     */
    protected function convert(&$data, $origin)
    {
        if (empty($origin)) {
            throw new PropertyException("source Data Exception");
        }
        if ($this->checkConvert($origin, $data)) {
            $data = array_merge($origin, $data);
        } else {
            throw new PropertyException('service can not convert');
        }
    }

    /**
     * checkConvert
     *
     * @param $origin
     * @param $data
     * @return bool
     */
    protected function checkConvert($origin, $data)
    {
        if ($this->checkOptionType($origin, $data) == false) {
            return false;
        }
        return true;
    }

    protected function checkOptionType($origin, $data)
    {
        if (!empty($origin['option']['type']) && isset($data['option']['type'])) {
            if (key($data['option']['type']) != key($origin['option']['type'])) {
                return in_array($this->type, static::enableOptionTypeMap());
            }
        }
        return true;
    }

}