<?php

namespace Center\Capsule\Services\Property\Preset\Conf;


use Center\Capsule\Services\Property\Preset\Conf\Traits\OptionTrait;
use Illuminate\Support\Facades\Storage;

class LocateProperty
{
    const DATA_KEY = 'division';

    use OptionTrait;

    /**
     * conf
     *
     * @return array
     * @throws \Illuminate\Contracts\Filesystem\FileNotFoundException
     */
    public static function conf()
    {
        return [
            "key"        => "",
            "name"       => "位置",
            "type"       => "locate",
            "option"     => [
                "type" => [
                    //地址
                    "address" => [
                        "division_data" => static::getDivisionData(),
                        "province"      => "",
                        "city"          => "",
                        "county"        => "",
                        "address"       => ""
                    ],
                    //经纬度
                    "lng_lat" => [
                        "lng" => 0.00,
                        "lat" => 0.00
                    ],
                    "ip"      => [
                        "ip" => "127.0.0.1",
                        "type" => 4
                    ]
                ],

            ],
            "visibility" => 1,
            "value"      => []
        ];
    }

    public static function getData()
    {
        return dirname(dirname(__FILE__)).'/Data/division.json';
    }

    /**
     * getDivisionData
     *
     * @return mixed
     */
    public static function getDivisionData()
    {
        $path = static::getData();
        $content = file_get_contents($path);
        //if(Storage::disk('local')->exists($path)){
            //$content = Storage::disk('local')->get($path);
        //}
        return json_decode($content, true);
    }
}