<?php

namespace Center\Capsule\Services\Record\Resolve;


use Center\Capsule\Services\Models\Facades\Model;
use Center\Capsule\Services\Record\Traits\BuildTrait;
use Center\Capsule\Services\Record\Traits\TransTrait;

/**
 * Class Insert
 * @package Center\Capsule\Services\Record\Resolve
 * @author 周阳阳 09点28分
 */
class Insert
{
    use BuildTrait, TransTrait;

    private $insertId = 0;

    public $insertData = [];

    /**
     * buildInsertData
     *
     * @return $this
     */
    public function buildInsertData()
    {
        $allow = array_keys(Model::getAllowProperties($this->modelKey));
        foreach ($this->injectData as $property => $val) {
            if (in_array($property, $allow)) {
                $this->insertData[$property] = $this->transValues($val, $property);
            }
        }
        $this->insertId = $this->insertData['id'] = app('snowflake')->id();
        return $this;
    }

    /**
     * insert
     *
     * @return bool
     */
    public function insert()
    {
        foreach ($this->insertData as $k=>$v){
            $this->model->{$k} = $v;
        }
        return $this->model->save();
    }

    /**
     * getInsertId
     *
     * @return int
     */
    public function getInsertId()
    {
        return $this->insertId;
    }
}