<?php

namespace Center\Capsule\Services\Record\Resolve;


use Center\Capsule\Services\Models\Facades\Model;
use Center\Capsule\Services\Record\Traits\BuildTrait;
use Center\Capsule\Services\Record\Traits\TransTrait;

class Put
{
    use BuildTrait, TransTrait;

    private $id = 0;

    private $ids = [];

    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    public function setIds($id)
    {
        $this->ids = is_array($id) ? $id : explode(',', $id);
        return $this;
    }

    /**
     * update
     *
     * @return bool
     */
    public function update()
    {
        $model = $this->model::findOrFail($this->id);
        $allow =  array_keys(Model::getAllowProperties($this->modelKey));
        foreach ($this->injectData as $property => $val) {
            if (in_array($property, $allow)) {
                $model->{$property} = $this->transValues($val, $property);
            }
        }
        return $model->save();
    }

    /**
     * delete
     *
     * @return mixed
     */
    public function delete()
    {
        return $this->init()->model::query()
            ->whereIn('id', $this->ids)
            ->where('company_id', $this->companyId)->delete();
    }

    /**
     * 排序
     *
     * @param int $id
     * @return bool
     */
    public function sort()
    {
        $entity         = $this->model::findOrFail($this->id);
        $positionEntity = $this->model::findOrFail(static::$request->get('positionEntityId'));

        if (static::$request->get('type') == 'after') {
            $entity->moveAfter($positionEntity);
        } else {
            $entity->moveBefore($positionEntity);
        }

        return true;
    }


}