<?php

namespace Center\Capsule\Services\Record\Traits;

use Center\Capsule\Models\BaseModel;
use Center\Capsule\Services\Models\Facades\Model;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Http\Request;

trait BuildTrait
{
    /**
     * @var Request
     */
    protected static $request;

    protected $modelKey = '';

    protected $properties;

    /**
     * @var BaseModel|Builder
     */
    protected $model;

    protected $companyId;

    protected $jsonKeys = [];

    protected $users;

    public $injectData = [];

    private function init()
    {
        static::$request = request();
        $this->getModel();
        $this->getProperties();
        $this->companyId = static::$request->header('X-COMPANY-ID');
        return $this;
    }

    public function injectData(array $data)
    {
        $this->init();
        $this->injectData = $data;
        return $this;
    }



    public function setModelKey(string $key)
    {
        $this->modelKey = $key;
        return $this;
    }

    /**
     * 获取模型信息
     *
     * @return \Center\Capsule\Models\BaseModel
     */
    public function getModel()
    {
        $this->model = Model::getModel($this->modelKey);
        //处理模型关联
        $this->getRelation();
        return $this->model;
    }

    public function getRelation()
    {
        //
    }


    /**
     * 获取属性信息
     *
     * @return Builder[]|Collection
     */
    private function getProperties()
    {
        $this->properties = Model::getProperties($this->modelKey);
        return $this->properties;
    }

    public function filter()
    {
        if (!empty($this->injectData)) {
            //todo
        }
    }

}