<?php

namespace Center\Capsule\Services\User;


use Center\Capsule\Constants\ServiceConst;
use Center\Capsule\Services\Extra\RequestService;
use Illuminate\Support\Facades\Log;

class UserService
{
    /**
     * getLoginUser
     *
     * @return array|null
     * @throws \GuzzleHttp\Exception\GuzzleException
     * @throws \Exception
     */
    public static function getLoginUser()
    {
        static $user_info = null;

        if (is_null($user_info)) {
            $config = config('capsule');
            $uri    = ServiceConst::getServiceHost('user').$config['user']['get_user_info'];
            try {
                $header   = [
                    'X-USER-ID'    => request()->header('X-USER-ID'),
                    'X-COMPANY-ID' => request()->header('X-COMPANY-ID'),
                    'X-API-SOURCE' => request()->header('X-API-SOURCE')
                ];
                $response = RequestService::getInstance()->get($uri,
                    [], $header);
                if ($response->isSuccess()) {
                    $user_info = $response->getResult();
                } else {
                    $user_info = [];
                }
            } catch (\Exception $e) {
                //add log
                Log::warning("getLoginUser:{$e->getMessage()}");
            }
            $user_info['current_company_id'] = request()->header('X-COMPANY-ID');
        }
        return $user_info;
    }
}